<!--#include file="settings.asp"-->
<!--#include file="design/start.asp"-->
<!--#include file="subs/designSettings.asp"-->

<!--#include file="subs/utilUpdates.asp"-->
<!--#include file="language/language.asp"-->

<script language="JavaScript">
function updatePatch(uFolder, uDescription) {
	if (confirm ("Are you sure you want to update this patch ? You cannot undo the operation !"))
		document.location = "updatesExecute.asp?updateFolder="+uFolder+"&updateDescription="+uDescription;

}
</script>

<%
'---------------------------------------------------------------------
if session("goMall") <> "yes" then
	set storeConn = nothing
	response.redirect "default.asp"
end if
'---------------------------------------------------------------------

const nInfo = 1
const nFiles = 4
const nDatabase = 2
const fieldSep = "~"

dim okInfo, okFiles, okDatabase
dim ftpConn
dim ftpAddress, ftpUser, ftpPassword
dim remoteFile, localFile

dim fs, file, line
dim fieldsInfoHeader(), fieldsInfoData(), fieldInfo
dim fieldsFilesHeader(), fieldsFilesData(), fieldFiles
dim fieldsDatabaseHeader(), fieldsDatabaseData(), fieldDatabase

dim updateFolder, updateDescription

dim uboundLimit, uboundFiles, uboundDatabase
dim count, count2
dim fileOperationDisplay, filePlaceInDisplay

ftpAddress = "ftp.spidersales.com"
remoteFile = "/info.csv"
localFile = pathApp()&"mallAdmin\Updates\info.csv"
ftpUser = "spider"
ftpPassword = "spider"

'---------------------------------- download and test info file -------------------------------
on error resume next
set ftpConn = Server.CreateObject("AspInet.FTP")
if err <> 0 then
	set storeConn = nothing
	session("errMessage") = AspInet_component_is_not_installed_CONST
	response.redirect "error.asp"
end if

okInfo = ftpConn.FTPGetFile(ftpAddress, ftpUser, ftpPassword, remoteFile, localFile, false, 2)
if okInfo then
	set fs = Server.CreateObject("Scripting.FileSystemObject")
	Set file = fs.OpenTextFile(localFile, 1)
	if err <> 0 then
		okInfo = false
	end if
	if file.AtEndOfStream then
		okInfo = false
	end if
end if
if okInfo then
	call loadFieldDefs()
	line = file.readline
	okInfo = testHeader(line, fieldsInfoHeader)
end if
if okInfo then
	count = 0
	while not file.AtEndOfStream
		line = file.readline
		if loadInfoFile(line, count) then
			count = count + 1
		end if
	wend
	if fieldsInfoData(0) = "" then
		okInfo = false
	else
		uboundLimit = ubound(fieldsInfoData)
	end if
end if
set line = nothing
set file = nothing

if okInfo then
	call startWindow ("Found new patches/updates","100%", false)
else
	call startWindow ("No patch/update available","100%", false)
end if
%>

<table border="0" width="100%" cellspacing="1" cellpadding="1">
<% if not okInfo then %>
<tr>
	<td><div id="normalText">There are no patches/updates available now</div></td>
</tr>
<%
else %>
	<tr>
		<td colspan="2"><div id="normalText">Before updating any patch we strongly recommend you to run <a href="../Diags/default.asp" target="_blank">Spider Sales diagnostic tool</a>
			<br>The diagnostic tool allow you if the application has writing permissions in Spider Sales folders.
			<br>Also, we recommend you to read carefully the patch description.
			<br>If you changed the source code of Spider Sales do not run the patch.
			<br>For more information's, contact our support team.
		</div></td>
	</tr>
	<tr>
		<td colspan="2"><br></td>
	</tr>
	<% for count = 0 to uboundLimit
		'---------------------------------- download and test files ----------------------------------
		fieldInfo = split(fieldsInfoData(count), fieldSep)
		updateFolder = fieldInfo(0)
		updateDescription = fieldInfo(1)
		remoteFile = "/"&updateFolder&"/files.csv"
		localFile = pathApp()&"mallAdmin\Updates\files.csv"
		okFiles = ftpConn.FTPGetFile(ftpAddress, ftpUser, ftpPassword, remoteFile, localFile, false, 2)
		if okFiles then
			Set file = fs.OpenTextFile(localFile, 1)
			if err <> 0 then
				okFiles = false
			end if
			if file.AtEndOfStream then
				okFiles = false
			end if
		end if
		if okFiles then
			line = file.readline
			okFiles = testHeader(line, fieldsFilesHeader)
		end if
		if okFiles then
			count2 = 0
			while not file.AtEndOfStream
				line = file.readline
				if loadFiles(line, count2) then
					count2 = count2 + 1
				end if
			wend
			if fieldsFilesData(0) = "" then
				okFiles = false
			else
				uboundFiles = ubound(fieldsFilesData)
			end if
		end if
		set line = nothing
		set file = nothing
		'---------------------------------- download and test database files ----------------------------------
		remoteFile = "/"&updateFolder&"/database.csv"
		localFile = pathApp()&"mallAdmin\Updates\database.csv"
		okDatabase = ftpConn.FTPGetFile(ftpAddress, ftpUser, ftpPassword, remoteFile, localFile, false, 2)
		if okDatabase then
			Set file = fs.OpenTextFile(localFile, 1)
			if err <> 0 then
				okDatabase = false
			end if
			if file.AtEndOfStream then
				okDatabase = false
			end if
		end if
		if okDatabase then
			line = file.readline
			okDatabase = testHeader(line, fieldsDatabaseHeader)
		end if
		if okDatabase then
			count2 = 0
			while not file.AtEndOfStream
				line = file.readline
				if loadDatabase(line, count2) then
					count2 = count2 + 1
				end if
			wend
			if fieldsDatabaseData(0) = "" then
				okDatabase = false
			else
				uboundDatabase = ubound(fieldsDatabaseData)
			end if
		end if
		set line = nothing
		set file = nothing
		if okFiles or okDatabase then %>
			<tr>
				<td colspan="2" bgcolor="#3399CC"><div id="normalText"><b>Patch name: <%= updateDescription %></b></div></td>
			</tr>
			<% if okFiles then %>
			<tr>
				<td width="5%" nowrap>&nbsp;</td>
				<td width="95%">
				<table border="0" width="100%" cellspacing="1" cellpadding="1">
				<tr>
					<td><input type="button" class="b1" value="Update patch" onClick="JavaScript:updatePatch('<%= updateFolder %>', '<%= updateDescription %>');"></td>
				</tr>
				<tr>
					<td><div id="normalText"><li>List of files/folders who will be modified in this patch</li></div></td>
				</tr>
				<tr>
					<td>
					<table class="table2" border="0" width="100%" cellspacing="0" cellpadding="3">
					<tr class="cell1">
						<td><div id="normalText"><b>Location</b></div></td>
						<td><div id="normalText"><b>Type</b></div></td>
						<td><div id="normalText"><b>Name</b></div></td>
						<td><div id="normalText"><b>Operation</b></div></td>
						<td><div id="normalText"><b>Place in</b></div></td>
						<td align="right"><img src="../admin/design/images/tD.gif" width="23" height="23"></td>
					</tr>
					<% for count2 = 0 to uboundFiles
						fieldFiles = split(fieldsFilesData(count2), fieldSep)
						fileOperationDisplay = ""
						if lcase(fieldFiles(3)) = "add" then
							if lcase(fieldFiles(1)) = "file" then
								fileOperationDisplay = fileOperationDisplay & "Add"
							else
								fileOperationDisplay = fileOperationDisplay & "Create"
							end if
						else
							fileOperationDisplay = fileOperationDisplay & "Delete "
						end if 
						if instr(lcase(fieldFiles(0)), "admin\blankstore") > 0 then
							filePlaceInDisplay = "Store"
						else
							filePlaceInDisplay = "Admin"
						end if
						%>
						<tr>
							<td><div id="normalText"><%= pathApp & fieldFiles(0) %></div></td>
							<td><div id="normalText"><%= fieldFiles(1) %></div></td>
							<td><div id="normalText"><%= fieldFiles(2) %></div></td>
							<td><div id="normalText"><%= fileOperationDisplay %></div></td>
							<td><div id="normalText"><%= filePlaceInDisplay %></div></td>
							<td>&nbsp;</td>
						</tr>
					<% next %>
					</table>
					</td>
				</tr>
				</table>
				</td>
			</tr>
			<% end if
			if okDatabase then %>
			<tr>
				<td width="5%" nowrap>&nbsp;</td>
				<td width="95%">
				<table border="0" width="100%" cellspacing="1" cellpadding="1">
				<tr>
					<td><div id="normalText"><li>Database queries who will be executed in the database</li></div></td>
				</tr>
				<tr>
					<td>
					<table class="table2" border="0" width="100%" cellspacing="0" cellpadding="3">
					<tr class="cell1">
						<td align="center"><div id="normalText"><b>Access Database</b></div></td>
						<td align="center"><div id="normalText"><b>SQL Database</b></div></td>
						<td align="center"><div id="normalText"><b>MySql Database</b></div></td>
						<td align="right"><img src="../admin/design/images/tD.gif" width="23" height="23"></td>
					</tr>
					<% for count2 = 0 to uboundDatabase
						fieldDatabase = split(fieldsDatabaseData(count2), fieldSep) %>
						<tr>
							<td valign="top"><div id="normalText"><%= fieldDatabase(0) %></div></td>
							<td valign="top"><div id="normalText"><%= fieldDatabase(1) %></div></td>
							<td valign="top"><div id="normalText"><%= fieldDatabase(2) %></div></td>
							<td>&nbsp;</td>
						</tr>
					<% next %>
					</table>
					</td>
				</tr>
				</table>
				</td>
			</tr>	
			<% end if %>
			<tr>
				<td><br></td>
			</tr>
		<% end if
	next
end if
%>	

</table>

<% call endWindow() %>
<!--#include file="design/end.asp"-->
<% 
set ftpConn = nothing
set fs = nothing
set storeConn = nothing %>
